/*
 *  sound.cpp
 *  lady million
 *
 *  Created by increpare on 20/08/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "sound.h"
#include <string>

using std::string;
DUH *music[musiccount];          /* Encapsulates the music file. */


void loadsample(int i, string s);
void loadmusic(int i, string s);



SAMPLE *sfx[samplecount];
AL_DUH_PLAYER *dplay; /* Holds the current playback state. */


string musicfile[musiccount] = {
"appintro.xm", //0: APPLICATION START
"bright.xm", //1: SELECT GAME
"ladymillionintro.xm",//2: INTRO
"mmtitlemusic.xm",//3: MM TITLE
"05_mmpassword.xm",//4: PASSWORD
"mmselectlevel.xm",//5: SELECT LEVEL
"bassline.xm",//6: LEVEL1
"jazzy.xm",//7: LEVEL2
"jazzy2.xm",//8: LEVEL3
"ladymillionpassword.xm",//9: LEVEL4
"level5.xm",//10: LEVEL5
"boss.xm",//11: BOSS
"mmend.xm",//12: WIN
"biocollect.xm",//13: SPECIMEN COLLECTOR
"selectgame.xm",//14: PANDA TITLE
"sickpanda.xm",//15: PANDA GAME
"selectgame.xm",//16: DANCE TITLE
"dancegame.xm",//17: DANCE GAME
"mmdead.xm",//18:megaman is dead/password display
"mmgetweapon.xm",//19:megaman beats a boss, gets weapon
"levelselected2.xm"//20:megaman: you've selected a level
};


string samplefile[samplecount]={
"explode.wav",
"fullplat.wav",
"halfplat.wav",
"jump.wav",
"land.wav",
"select.wav",
"shoot.wav",
"barriertick.wav",
"deflect.wav",
"playerhurt.wav",
"badpassword2.wav",//bad password
"goodpassword1.wav",//good password
"hair.wav",//hair fire
"hurtpanda.wav",//hurt panda
"itemchange.wav",//change menu item
"jawsnap.wav",//snap jaw
"milk.wav",//milk fire
"passwordchange.wav",//change password
"sadpanda.wav",//sad panda
"selectitem.wav",//select weapon
"stageselect.wav",//select stage
"baby.wav",//select stage
"teleport2.wav",//select stage
"teleport2b.wav",//select stage
};


void initaudio()
{
	
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	atexit(&dumb_exit);
	set_mixer_quality(0);
	// enable floating-point DSP
	//	BASS_SetConfig(BASS_CONFIG_FLOATDSP,TRUE);
	//	if (!BASS_Init(-1,44100,0,NULL,NULL)) {
	//		allegro_message("error with audio");
	//	}
	
	//load file
	
	//load sound effects
	for ( int i=0; i<samplecount;i++ ) 
		loadsample(i,samplefile[i]);
	
	dumb_register_stdfiles();
	
	for (int i=0;i<musiccount;i++)
		loadmusic(i, musicfile[i]);
	
	
	
}


void pollmusic()
{
	al_poll_duh(dplay);	
}

void playsample(int s)
{
play_sample(sfx[s], 255, pan, pitch, FALSE);
}

void stopmusic()
{
	//BASS_ChannelStop(curplay);	
	if (dplay!=NULL) 
	{
		al_stop_duh(dplay);
		dplay=NULL;
	}
}

void playmusic(int i)
{
	
	stopmusic();
	dplay=al_start_duh(music[i],1,0,1.0f, 4096*4,11025);
}


void loadsample(int i,string s)
{
	sfx[i]=load_wav(("wav/"+s).c_str());
}


void loadmusic(int i, string s)
{
	music[i] = dumb_load_xm_quick(("xm/"+s).c_str());
	//if (loop)
	//	chan[i]=BASS_MusicLoad(FALSE,musicfile[i],0,0,BASS_MUSIC_LOOP|BASS_MUSIC_MONO|BASS_MUSIC_RAMPS|floatable,0);
	// else
	//	chan[i]=BASS_MusicLoad(FALSE,musicfile[i],0,0,BASS_MUSIC_MONO|BASS_MUSIC_RAMPS|floatable,0);
}
